﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinProgressBar;

namespace Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = GetData();
        }

        private DataSet GetData()
        {
            Random randomGenerator = new Random();
            DataSet dataSet = new DataSet();
            DataTable firstTable = new DataTable();

            firstTable.Columns.Add("Identifier", typeof(int));
            firstTable.Columns.Add("Boolean Column", typeof(Boolean));
            firstTable.Columns.Add("Digits", typeof(int));
            firstTable.Columns.Add("ProgressBar Column", typeof(int));
            firstTable.Columns.Add("Button Column", typeof(string));

            for (int i = 1; i <= 10; i++)
            {
                DataRow currentRow = firstTable.NewRow();
                currentRow["Identifier"] = i;
                currentRow["Boolean Column"] = randomGenerator.Next(0, 10) % 2 == 0 ? true : false;
                currentRow["Digits"] = randomGenerator.Next(0, 10);
                firstTable.Rows.Add(currentRow);
            }
            dataSet.Tables.Add(firstTable);
            return dataSet;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraProgressBar progressBar = new UltraProgressBar();
            e.Layout.Bands[0].Columns["ProgressBar Column"].EditorComponent = progressBar;
            e.Layout.Bands[0].Columns["Button Column"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Button;
            e.Layout.Bands[0].Columns["Button Column"].ButtonDisplayStyle = ButtonDisplayStyle.Always;
        }

        private void ultraGrid1_ClickCellButton(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        {
            UltraGridCell progressBarCell = (UltraGridCell)e.Cell.Row.Cells["ProgressBar Column"];
            for (int i = 0; i <= 100; i++)
            {
                // The value of the cell is the actual underlying data value, which the ProgressBar value is binded to.
                progressBarCell.Value = i;
                // In order to visualize the update in the ProgressBar you have to update the grid 
                // or the cell that wraps the ProgressBar.
                this.ultraGrid1.Refresh();
                //progressBarCell.Refresh();
            }
        }
    }
}
